routes/web.php
<?php

use App\Http\Controllers\AlbumController;
use App\Http\Controllers\ArtistController;
use App\Http\Controllers\CartController;
use App\Http\Controllers\CustomerController;
use App\Http\Controllers\EmployeeController;
use App\Http\Controllers\IndexController;
use App\Http\Controllers\InvoiceController;
use App\Http\Controllers\PlaylistController;
use App\Http\Controllers\RoleController;
use App\Http\Controllers\TrackController;
use App\Http\Controllers\UserController;
use Illuminate\Support\Facades\Route;

/* Index : show all * Show : show one * Create : show form to create * Store : store new * Edit : show form to edit * Update : update * Destroy : delete */
Route::get('/', [IndexController::class, 'index'])->name('index');

Route::get('/register', [UserController::class, 'create'])->name('register');
Route::get('/login', [UserController::class, 'login'])->name('login');
Route::get('/logout', [UserController::class, 'logout'])->name('logout');

Route::name('users.')->group(function () {
    Route::post('/users/authenticate', [UserController::class, 'authenticate'])->name('authenticate');
    Route::post('/users', [UserController::class, 'store'])->name('store');
    Route::get('/account', [UserController::class, 'accountIndex'])->name('account');
    Route::patch('/users/{user}', [UserController::class, 'update'])->name('update');
});

Route::name('albums.')->group(function () {
    Route::get('/albums', [AlbumController::class, 'index'])->name('index');
    Route::get('/albums/create', [AlbumController::class, 'create'])->name('create');
    Route::post('/albums', [AlbumController::class, 'store'])->name('store');
    Route::get('/albums/export/', [AlbumController::class, 'export'])->name('export');
    Route::post('/albums/{album}/cart', [AlbumController::class, 'addToCart'])->name('cart');
    Route::get('/albums/{album}/export', [AlbumController::class, 'exportOne'])->name('export.one');
    Route::get('/albums/{album}/edit', [AlbumController::class, 'edit'])->name('edit');
    Route::post('/albums/{album}/restore', [AlbumController::class, 'restore'])->name('restore');
    Route::delete('/albums/{album}', [AlbumController::class, 'destroy'])->name('destroy');
    Route::put('/albums/{album}', [AlbumController::class, 'update'])->name('update');
    Route::get('/albums/{album}', [AlbumController::class, 'show'])->name('show');
});

Route::name('tracks.')->group(function () {
    Route::get('/tracks', [TrackController::class, 'index'])->name('index');
    Route::get('/tracks/create', [TrackController::class, 'create'])->name('create');
    Route::get('/tracks/{track}', [TrackController::class, 'edit'])->name('edit');
    Route::put('/tracks/{track}', [TrackController::class, 'update'])->name('update');
    Route::post('/tracks', [TrackController::class, 'store'])->name('store');
    Route::delete('/tracks/{track}', [TrackController::class, 'destroy'])->name('destroy');
    Route::post('/tracks/{track}/restore', [TrackController::class, 'restore'])->name('restore');
});

Route::name('artists.')->group(function () {
    Route::get('/artists', [ArtistController::class, 'index'])->name('index');
    Route::get('/artists/export', [ArtistController::class, 'export'])->name('export');
    Route::get('/artists/create', [ArtistController::class, 'create'])->name('create');
    Route::delete('/artists/{artist}', [ArtistController::class, 'destroy'])->name('destroy');
    Route::get('/artists/{artist}/edit', [ArtistController::class, 'edit'])->name('edit');
    Route::post('/artists/{artist}/restore', [ArtistController::class, 'restore'])->name('restore');
    Route::put('/artists/{artist}', [ArtistController::class, 'update'])->name('update');
    Route::post('/artists', [ArtistController::class, 'store'])->name('store');
});

Route::name('playlists.')->group(function () {
    Route::get('/playlists', [PlayListController::class, 'index'])->name('index');
    Route::get('/playlists/{playlist}/export', [PlaylistController::class, 'export'])->name('export');
    Route::get('/playlists/create', [PlaylistController::class, 'create'])->name('create');
    Route::get('/playlists/{playlist}', [PlayListController::class, 'show'])->name('show');
    Route::get('/playlists/{playlist}/create', [PlaylistController::class, 'createTrack'])->name('tracks.create');
    Route::post('/playlists/{playlist}', [PlayListController::class, 'storeTrack'])->name('tracks.store');
    Route::delete('/playlists/{playlist}', [PlaylistController::class, 'destroy'])->name('destroy');
    Route::delete('/playlists/{playlist}/{track}', [PlayListController::class, 'destroyTrack'])->name('destroy.track');
    Route::post('/playlists', [PlayListController::class, 'store'])->name('store');
});

Route::name('invoices.')->group(function () {
    Route::get('/invoices', [InvoiceController::class, 'index'])->name('index');
    Route::delete('/invoices/{invoice}', [InvoiceController::class, 'destroy'])->name('destroy');
    Route::get('/invoices/{invoice}', [InvoiceController::class, 'show'])->name('show');
});

Route::name('cart.')->group(function () {
    Route::get('/cart', [CartController::class, 'index'])->name('index');
    Route::get('/cart/success', [CartController::class, 'success'])->name('success');
    Route::post('/cart', [CartController::class, 'store'])->name('store');
    Route::post('/cart/create-step-one', [CartController::class, 'createStepOneStore'])->name('create.step.one.store');
    Route::post('/cart/{track}', [CartController::class, 'addToCart'])->name('add');
    Route::delete('/cart/{id}', [CartController::class, 'deleteFromCart'])->name('delete');
    // we could use PUT if route --> /cart/{id}/quantity
    Route::patch('/cart/{id}', [CartController::class, 'update'])->name('update');
});

Route::name('customers.')->group(function () {
    Route::get('/customers', [CustomerController::class, 'index'])->name('index');
    Route::get('/customers/create', [CustomerController::class, 'create'])->name('create');
    Route::delete('/customers/{customer}', [CustomerController::class, 'destroy'])->name('destroy');
    Route::post('/customers', [CustomerController::class, 'store'])->name('store');
    Route::get('/customers/{customer}/edit', [CustomerController::class, 'edit'])->name('edit');
    Route::post('/customers/{customer}/restore', [CustomerController::class, 'restore'])->name('restore');
    Route::put('/customers/{customer}', [CustomerController::class, 'update'])->name('update');
});

Route::name('employees.')->group(function () {
    Route::get('/employees', [EmployeeController::class, 'index'])->name('index');
    Route::get('/employees/create', [EmployeeController::class, 'create'])->name('create');
    Route::delete('/employees/{employee}', [EmployeeController::class, 'destroy'])->name('destroy');
    Route::post('/employees', [EmployeeController::class, 'store'])->name('store');
    Route::get('/employees/{employee}/edit', [EmployeeController::class, 'edit'])->name('edit');
    Route::post('/employees/{employee}/restore', [EmployeeController::class, 'restore'])->name('restore');
    Route::put('/employees/{employee}', [EmployeeController::class, 'update'])->name('update');
    Route::post('/employees/{employee}/account', [EmployeeController::class, 'storeAccount'])->name('store.account');
});

Route::name('roles.')->group(function () {
    Route::get('/roles', [RoleController::class, 'index'])->name('index');
    Route::get('/roles/create', [RoleController::class, 'create'])->name('create');
    Route::post('/roles', [RoleController::class, 'store'])->name('store');
    Route::get('/roles/{role}/edit', [RoleController::class, 'edit'])->name('edit');
    Route::put('/roles/{role}', [RoleController::class, 'update'])->name('update');
    Route::delete('/roles/{role}', [RoleController::class, 'destroy'])->name('destroy');
});

Route::fallback(fn () => abort(404));

app/Models/Employee.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\BelongsTo;
use Illuminate\Database\Eloquent\Relations\HasMany;
use Illuminate\Database\Eloquent\SoftDeletes;
use Kyslik\ColumnSortable\Sortable;

class Employee extends Model
{
    use HasFactory, Sortable, SoftDeletes;

    protected $fillable = ['firstname', 'lastname',  'company',  'address', 'city', 'state', 'country', 'postalcode', 'phone', 'fax', 'email', 'employee_id'];
    protected $sortable = ['id', 'firstname', 'lastname', 'email', 'phone', 'city', 'country', 'title'];
    protected $with = ['user'];

    public function customers(): HasMany {
        return $this->hasMany(Customer::class, 'employee_id');
    }

    public function employee(): BelongsTo {
        return $this->belongsTo(Employee::class, 'reportsto');
    }

    public function user(): BelongsTo {
        return $this->belongsTo(User::class, 'user_id');
    }

    public function scopeFilter($query, array $filter) {
        if ($filter['search'] ?? false)
            return $query->where('lastname', 'like', '%' . $filter['search'] . '%')
                ->orWhere('firstname', 'like', '%' . $filter['search'] . '%')
                ->orWhere('title', 'like', '%' . $filter['search'] . '%')
                ->orWhere('city', 'like', '%' . $filter['search'] . '%')
                ->orWhere('postalcode', '=', $filter['search'])
                ->orWhere('email', 'like', '%' . $filter['search'] . '%');
        return $query;
    }

    public static function boot() {
        parent::boot();
        static::deleting(fn($employee) => $employee->user()->delete());
        static::restoring(fn($employee) => $employee->user()->restore());
    }
}

app/Http/Controllers/EmployeeController.php
<?php

namespace App\Http\Controllers;

use App\Models\Employee;
use App\Models\User;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Hash;
use Illuminate\Support\Str;
use Illuminate\Validation\Rule;
use Spatie\Permission\Models\Role;

class EmployeeController extends Controller
{
    public function __construct(){
        $this->middleware('auth');
        $this->middleware('permission:employees.show')->only('index');
        $this->middleware('permission:employees.edit')->only(['edit', 'update', 'storeAccount']);
        $this->middleware('permission:employees.delete')->only(['destroy', 'restore']);
        $this->middleware('permission:employees.create')->only(['create', 'store']);
    }

    public function index(){
        $employees = auth()->user()->can('employees.delete') ? Employee::withTrashed() : Employee::withoutTrashed();
        $employees = $employees->filter(\request()->input())->sortable()->latest()->paginate(10);
        return view('employees.index', ['employees' => $employees]);
    }

    public function create(){
        return view('employees.create', ['employee' => new Employee]);
    }

    public function edit(Employee $employee){
        $roles = Role::where('name', '!=', 'super admin')->get();
        return view('employees.edit', ['employee' => $employee, 'roles' => $roles]);
    }

    public function destroy(Employee $employee){
        $employee->delete();
        return back()->with('success', 'Suppression de l\'employé avec succès !');
    }

    public function restore($employeeId){
        $employee = Employee::onlyTrashed()->findOrFail($employeeId);
        $employee->restore();
        return back()->with('success', 'Employé restauré avec succès.');
    }

    public function update(Request $request, Employee $employee){
        $formFields = [
            'lastname' => ['required', 'min:2'],
            'firstname' => ['required', 'min:2'],
            'roles.*' => Rule::exists('roles', 'id')
        ];

        if ($request->input('email') != $employee->email)
            $formFields['email'] = 'email:rfc,dns|unique:employees';

        $request->validate($formFields);

        if($employee->user()->exists())
            $employee->user->syncRoles($request->input('roles'));

        $employee->updateOrFail($request->input());

        return back()->with('success', 'Modification réussie avec succès !');
    }

    public function store(Request $request){
        $request->validate([
            'lastname' => ['required', 'min:2'],
            'firstname' => ['required', 'min:2'],
            'email' => 'email:rfc,dns|unique:employees'
        ]);

        $fields = $request->input();
        $fields['reportsto'] = $request->user()->employee->id;

        Employee::create($fields);

        return back()->with('success', 'Création réussie avec succès !');
    }

    public function storeAccount(Request $request, Employee $employee){
        $password = Str::random(8);

        $user = User::firstOrCreate(['email' => $employee->email], [
            'name' => $employee->lastname,
            'email' => $employee->email,
            'password' => Hash::make($password)
        ]);

        $employee->user()->associate($user);
        $employee->save();

        return back()->with('success', 'Enregistrez bien le mot de passe : '.$password);
    }
}

resources/views/employees/create.blade.php
<x-layout>
    {{ Breadcrumbs::render() }}
    <x-title>
        <x-slot name="pageHeading">
            Création d'un <span class="text-blue-600">employé</span>
        </x-slot>
        <a href="{{ route('employees.index') }}" class="cursor-pointer w-full px-4 py-2 text-sm text-white font-medium bg-blue-500 hover:bg-blue-600 border border-blue-600 rounded-md shadow-button">
            Liste des employés
        </a>
    </x-title>
    <section class="pt-10">
        <div class="container px-4 mx-auto">
            <div class="flex max-w-lg mx-auto flex-col">
                <div class="p-8 bg-white rounded shadow">
                    <div class=" text-center">
                        <span class="text-sm text-blueGray-400 content-center">Employés</span>
                        <h4 class="mb-6 text-3xl">Créer un employé</h4>
                    </div>
                    <form method="POST" action="{{route('employees.store')}}" role="form" enctype="multipart/form-data">
                        @csrf
                        @include('employees.form')
                        <button type="submit" class="block mt-4 w-full p-4 text-center text-xs text-white font-semibold leading-none bg-blue-600 hover:bg-blue-700 rounded">Ajouter l'employé</button>
                    </form>
                </div>
            </div>
        </div>
    </section>
</x-layout>

resources/views/employees/edit.blade.php
<x-layout>
    {{ Breadcrumbs::render() }}

    <x-title>
        <x-slot name="pageHeading">
            Gestion d'un <span class="text-blue-600">employé</span>
        </x-slot>
        @if(is_null($employee->user))
            <form action="{{ route('employees.store.account', $employee->id) }}" method="POST" class="inline m-0">
                @csrf
                <button class="mr-1 cursor-pointer px-4 py-2 text-sm text-white font-medium bg-green-500 hover:bg-green-600 border border-green-600 rounded-md shadow-button">
                    Créer un compte utilisateur
                </button>
            </form>
        @endif
        <a href="{{ route('employees.index') }}" class="cursor-pointer w-full px-4 py-2 text-sm text-white font-medium bg-blue-500 hover:bg-blue-600 border border-blue-600 rounded-md shadow-button">
            Liste des employés
        </a>
    </x-title>

    <div class="grid grid-cols-1 lg:grid-cols-1 gap-6 mt-10 max-w-3xl mx-auto">
        <div class="p-6 bg-white rounded shadow">
            <div class=" text-center">
                <span class="text-sm text-blueGray-400 content-center">Employés</span>
                <h4 class="mb-6 text-3xl">Modifier un employé</h4>
            </div>
            <form method="POST" action="{{ route('employees.update', $employee->id) }}" role="form" enctype="multipart/form-data">
                @method('PUT')
                @csrf
                @include('employees.form')
                @if(!is_null($employee->user))
                    <label for="country" class="block mt-4">Rôles de l'utilisateur:</label>
                    <select class="appearance-none w-full p-4 text-xs font-semibold leading-none bg-blueGray-50 rounded outline-none h-32" name="roles[]" multiple>
                        @foreach($roles as $role)
                            <option value="{{$role->id}}" @if($employee->user->hasRole($role)) selected @endif>{{$role->name}}</option>
                        @endforeach
                    </select>
                    @error('artist')<p class="text-red-500 text-xs">{{$message}}</p>@enderror
                @endif
                <button type="submit" class="block mt-5 w-full p-4 text-center text-xs text-white font-semibold leading-none bg-blue-600 hover:bg-blue-700 rounded">Modifier les informations</button>
            </form>
        </div>
    </div>
</x-layout>

resources/views/employees/form.blade.php
<div class="flex -mx-3 mt-4">
    <div class="flex-col w-1/2 px-3">
        <label for="lastname">Nom:</label>
        <div class="w-full bg-blueGray-50 rounded">
            <input value="{{$employee?->lastname ?? @old('lastname')}}"
                   class="appearance-none w-full p-4 text-xs font-semibold leading-none bg-blueGray-50 rounded outline-none @error('lastname') border-2 border-red-500 @enderror"
                   type="text" name="lastname" required>
            @error('lastname')<p class="text-red-500 text-xs italic">{{$message}}</p>@enderror
        </div>
    </div>
    <div class="flex-col w-1/2 px-3">
        <label for="firstname">Prénom:</label>
        <div class="flex w-full bg-blueGray-50 rounded">
            <input value="{{$employee?->firstname ?? @old('firstname')}}"
                   class="appearance-none w-full p-4 text-xs font-semibold leading-none bg-blueGray-50 rounded outline-none @error('firstname') border-2 border-red-500 @enderror"
                   type="text" name="firstname" required>
            @error('firstname')<p class="text-red-500 text-xs italic">{{$message}}</p>@enderror
        </div>
    </div>
</div>

<label for="country" class="block mt-4">Titre:</label>
<input value="{{$employee->title ?? @old('title')}}"
       class="appearance-none w-full p-4 text-xs font-semibold leading-none bg-blueGray-50 rounded outline-none"
       type="text" name="title">

<label for="address" class="block mt-4">Adresse:</label>
<input value="{{$employee->address ?? @old('address')}}"
       class="appearance-none w-full p-4 text-xs font-semibold leading-none bg-blueGray-50 rounded outline-none @error('address') border-2 border-red-500 @enderror"
       type="text" name="address">

<div class="flex -mx-3 mt-4">
    <div class="flex-col w-1/3 px-3">
        <label for="postalcode">Code postal:</label>
        <div class="flex w-full bg-blueGray-50 rounded">
            <input value="{{$employee->postalcode ?? @old('postalcode')}}"
                   class="appearance-none w-full p-4 text-xs font-semibold leading-none bg-blueGray-50 rounded outline-none @error('postalcode') border-2 border-red-500 @enderror"
                   type="text" name="postalcode">
        </div>
    </div>
    <div class="flex-col w-2/3 px-3">
        <label for="city">Ville:</label>
        <div class="flex w-full bg-blueGray-50 rounded">
            <input value="{{$employee->city ?? @old('city')}}"
                   class="appearance-none w-full p-4 text-xs font-semibold leading-none bg-blueGray-50 rounded outline-none"
                   type="text" name="city">
        </div>
    </div>
</div>

<label for="country" class="block mt-4">Pays:</label>
<input value="{{$employee->country ?? @old('country')}}"
       class="appearance-none w-full p-4 text-xs font-semibold leading-none bg-blueGray-50 rounded outline-none"
       type="text" name="country">

<label for="phone" class="block mt-4">Téléphone:</label>
<input value="{{$employee->phone ?? @old('phone')}}"
       class="appearance-none w-full p-4 text-xs font-semibold leading-none bg-blueGray-50 rounded outline-none"
       type="text" name="phone">

<label for="company" class="block mt-4">Email:</label>
<input value="{{$employee->email ?? @old('email')}}"
       class="appearance-none w-full p-4 text-xs font-semibold leading-none bg-blueGray-50 rounded outline-none @error('email') border-2 border-red-500 @enderror"
       type="email" name="email" required>
@error('email')<p class="text-red-500 text-xs italic">{{$message}}</p>@enderror

resources/views/employees/index.blade.php
<x-layout>
    {{ Breadcrumbs::render() }}

    <x-search title="des employés" searchBy="Cherchez par nom, prénom, ville, email ou encore titre." />

    <x-title>
        <x-slot name="pageHeading">
            Liste des <span class="text-blue-600">employés</span>
        </x-slot>
        @can('employees.create')
            <a href="{{ route('employees.create') }}" class="cursor-pointer w-full px-4 py-2 text-sm text-white font-medium bg-green-500 hover:bg-green-600 border border-green-600 rounded-md shadow-button">
                Ajouter un employé
            </a>
        @endcan
    </x-title>

    <div class="mt-5 bg-blue-100 border-l-4 border-blue-500 text-blue-700 p-4" role="alert">
        <p>Besoin de créer un compte utilisateur à l'un de vos employés ? <strong>Créez-le directement via la page édition !</strong><br /> Vous pourrez ensuite directement lui assigner des rôles via cette même page.</p>
    </div>

    <div class="relative overflow-x-auto shadow-md sm:rounded-lg mt-5">
        <table class="w-full text-sm text-left text-gray-500 dark:text-gray-400">
            <thead class="text-xs text-gray-700 uppercase bg-gray-50 dark:bg-gray-700 dark:text-gray-400">
            <tr>
                <th scope="col" class="px-6 py-3">@sortablelink('lastname', 'Nom')</th>
                <th scope="col" class="px-6 py-3">@sortablelink('email', 'Email')</th>
                <th scope="col" class="px-6 py-3">@sortablelink('phone', 'Téléphone')</th>
                <th scope="col" class="px-6 py-3">@sortablelink('city', 'Ville')</th>
                <th scope="col" class="px-6 py-3">@sortablelink('country', 'Pays')</th>
                <th scope="col" class="px-6 py-3">@sortablelink('title', 'Titre')</th>
                <th scope="col" class="px-6 py-3"><span class="sr-only">Actions</span></th>
            </tr>
            </thead>
            <tbody>
            @foreach($employees as $employee)
                <tr class="bg-white border-b">
                    <th scope="row" class="px-6 py-4 font-medium text-gray-900 dark:text-white whitespace-nowrap">{{ $employee->lastname }} {{ $employee->firstname }}</th>
                    <td class="px-6 py-4">{{ $employee->email }}</td>
                    <td class="px-6 py-4">{{ $employee->phone ?? '-' }}</td>
                    <td class="px-6 py-4">{{ $employee->city ?? '-' }}</td>
                    <td class="px-6 py-4">{{ $employee->country ?? '-' }}</td>
                    <td class="px-6 py-4">{{ $employee->title ?? '-' }}</td>
                    <td class="px-6 py-4">
                        <div class="flex justify-end">
                            @unless($employee->trashed())
                                @can('employees.edit')
                                    <a class="border rounded hover:bg-gray-50 font-semibold py-1 px-2" href="{{route('employees.edit', $employee)}}">✏</a>
                                @endcan
                                @can('employees.delete')
                                    <form action="{{route('employees.destroy', $employee)}}" method="POST">
                                        @csrf @method('DELETE') <button type="submit" class="border hover:bg-gray-50 font-semibold py-1 px-2 rounded ml-2">❌</button>
                                    </form>
                                @endcan
                            @else
                                <form action="{{ route('employees.restore', $employee) }}" method="POST">
                                    @csrf
                                    <button type="submit" class="border hover:bg-gray-50 font-semibold py-1 px-2 rounded">🔓</button>
                                </form>
                            @endunless
                        </div>
                    </td>
                </tr>
            @endforeach
            </tbody>
        </table>
    </div>

    @if ($employees->hasPages())
        <div class="mt-10">
            {!! $employees->appends(\Request::except('page'))->render() !!}
        </div>
    @endif
</x-layout>